unit UnidadExportar;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FileCtrl, ComCtrls, DB, KDaoTable, KDaoDataBase, daoapi,StrUtils;

type
  TformExportar = class(TForm)
    lInfoProgreso: TLabel;
    GroupBox1: TGroupBox;
    cfFichero: TLabel;
    cfCIF: TLabel;
    cfNombre: TLabel;
    cfCCC: TLabel;
    bpLineas: TProgressBar;
    bIniciarExportacion: TButton;
    bCerrar: TButton;
    bCancelar: TButton;
    procedure FormCreate(Sender: TObject);
    procedure bIniciarExportacionClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure bCerrarClick(Sender: TObject);
    procedure bCancelarClick(Sender: TObject);
  private
    cancelar : boolean;
    fichero : string;
    CCC : string;
    CIF : string;
    Nombre : string;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formExportar: TformExportar;

implementation

uses
  unidadProcedimientos;
{$R *.dfm}

procedure TformExportar.FormCreate(Sender: TObject);
begin
  fichero := leCadINI('Configuracin', 'Fichero actualizar', '');
  CCC := leCadINI ('Configuracin', 'CCC', '');
  CIF := leCadINI('Configuracin', 'CIF', '');
  Nombre := leCadINI('Configuracin', 'Nombre', '');

  if (fichero = '') or (CCC = '') or (CIF = '') or (Nombre = '') then
  begin
    MessageDlg('Antes de iniciar la exportacin debe configurar todas ' +
        'las opciones de la aplicacin.', mtWarning, [mbok], 0);
    bIniciarExportacion.Enabled := false;
  end;
  cfFichero.Caption := 'Fichero: ' + fichero;
  cfCIF.Caption := 'CIF: ' + CIF;
  cfNombre.Caption := 'Nombre: ' + Nombre;
  cfCCC.Caption := 'CCC: ' + CCC;
end;

procedure TformExportar.bIniciarExportacionClick(Sender: TObject);
var
  i, j : integer;
  lineasActualizadas : Integer;
  lineaTemp : string;
  parteP, parteS, parteU, parteCCC : string;
  mTempSal, mTemp : TStringList;
begin
  lineasActualizadas := 0;
  if not FileExists(fichero) then
    MessageDlg('El fichero a actualizar no existe: ' + fichero,
        mtError, [mbyes, mbno], 0)
  else
  begin
    mTempSal := TStringList.Create;
    mTemp := TStringList.Create;
    Screen.Cursor := crHourGlass;
    bCancelar.Enabled := True;
    mTemp.Clear;
    lInfoProgreso.Caption := 'Actualizando fichero...';
    lInfoProgreso.Refresh;
    mTemp.LoadFromFile(fichero);
    //Inicio de la actualizacin
    bpLineas.Min := 0;
    bpLineas.Max := mTemp.Count;
    for i := 0 to mTemp.count - 1 do
    begin
      lineasActualizadas := lineasActualizadas + 1;
      Application.ProcessMessages;
      if not cancelar then
      begin
        bpLineas.Position := i;
        lineaTemp := mTemp.Strings[i];
        //actualizar Nombre (lnea 0 y 1, posicin 28
        if (i = 0) or (i = 1) then
        begin
          parteP := Copy (lineaTemp, 1, 4);
          parteS := Copy (lineaTemp, 14, 15);
          parteU := Copy (lineaTemp, 69, length (lineaTemp));
          //fijamos el nombre a 40 caracteres
          for j := 0 to 39 - length(nombre) do
            Nombre := nombre + ' ';
          //fijamos el CIF a 9 caracteres
          for j := 0 to 8 - length(CIF) do
            CIF := CIF + ' ';
          //fijamos el CCC a 20 caracteres
          for j := 0 to 19 - length(CCC) do
            CCC := CCC + ' ';
          //slo en la lnea 2 cambiar CCC
          if i = 1 then
             parteCCC := copy (lineaTemp, 89, length(lineaTemp));
          //montamos la lnea definitiva
          if i = 0 then
            lineaTemp := parteP + CIF + parteS + Nombre + parteU;
          if i = 1 then
            lineaTemp := parteP + CIF + parteS + Nombre + CCC + parteCCC;
        end
        else //para el resto de las lneas, cambiar slo el CIF
        begin
          //fijamos el CIF a 9 caracteres
          for j := 0 to 8 - length(CIF) do
            CIF := CIF + ' ';
          parteP := Copy (lineaTemp, 1, 4);
          parteU := Copy (lineaTemp, 14, length(lineaTemp));
          lineaTemp := parteP + CIF + parteU

        end;
        //Aadir linea al stringlist de salida
        mTempSal.Add(lineaTemp);
      end
      else
      begin
        bCancelar.Enabled := false;
        Screen.Cursor := crDefault;
        bpLineas.Position := 0;
        lInfoProgreso.Caption := 'Proceso cancelado por el usuario...';
        MessageDlg('El proceso de exportacin ha sido cancelado.',
          mtWarning, [mbok], 0);
        cancelar := false;
        exit;
      end;
    end;
    lInfoProgreso.Caption := 'Guardando cambios en fichero ' + fichero;
    lInfoProgreso.Refresh;
    mTemp.Destroy;
    mTempSal.SaveToFile(fichero);
    mTempSal.Destroy;
    bCancelar.Enabled := false;
    lInfoProgreso.Caption := 'Proceso finalizado correctamente';
    lInfoProgreso.Refresh;
    Screen.Cursor := crDefault;
    Application.ProcessMessages;
    bCerrar.SetFocus;
    MessageDlg('El proceso de actualizacin ha finalizado correctamente.',
        mtInformation, [mbok], 0);
    close;
  end;
end;

procedure TformExportar.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TformExportar.bCerrarClick(Sender: TObject);
begin
  Close;
end;

procedure TformExportar.bCancelarClick(Sender: TObject);
begin
  cancelar := true;
end;

end.
